// (c) Copyright 2012 Cloudera, Inc. All rights reserved.

define(["cloudera/Util","cloudera/common/DateUtil","cloudera/chart/TimeBrowserState","cloudera/chart/TimeRange","cloudera/common/TimeUtil"],function(e,t,n,r,i){var s=i.getServerTimezoneOffset(),o=2009;describe("TimeBrowserState Tests",function(){var e,t={firstDate:new Date(910),lastDate:new Date(1e3),firstVisibleDate:new Date(950),lastVisibleDate:new Date(1e3),markerDate:new Date(1e3),isCurrentMode:!0};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(i,"getServerNow").andReturn(new Date(1e3)),e=new n(t),e.getContainerWidth=function(){return o}}),afterEach(function(){}),it("should select a range.",function(){e.setSelectedRange(new r(new Date(940),new Date(960))),expect(e.firstDate.getTime()).toEqual(910),expect(e.lastDate.getTime()).toEqual(1e3),expect(e.firstVisibleDate.getTime()).toEqual(940),expect(e.lastVisibleDate.getTime()).toEqual(960)}),it("should select a range but not in the future.",function(){e.setSelectedRange(new r(new Date(950),new Date(1020))),expect(e.firstDate.getTime()).toEqual(910),expect(e.lastDate.getTime()).toEqual(1e3),expect(e.firstVisibleDate.getTime()).toEqual(930),expect(e.lastVisibleDate.getTime()).toEqual(1e3)}),it("should select a range even if the input is reversed.",function(){e.setSelectedRange(new r(new Date(1020),new Date(950))),expect(e.firstDate.getTime()).toEqual(910),expect(e.lastDate.getTime()).toEqual(1e3),expect(e.firstVisibleDate.getTime()).toEqual(930),expect(e.lastVisibleDate.getTime()).toEqual(1e3)}),it("should zoomOut in the present.",function(){e.zoomOut(),expect(e.firstDate.getTime()).toEqual(820),expect(e.lastDate.getTime()).toEqual(1e3),expect(e.firstVisibleDate.getTime()).toEqual(950),expect(e.lastVisibleDate.getTime()).toEqual(1e3)}),it("should zoom in.",function(){e.zoomIn(),expect(e.firstDate.getTime()).toEqual(950),expect(e.lastDate.getTime()).toEqual(1e3),expect(e.firstVisibleDate.getTime()).toEqual(950),expect(e.lastVisibleDate.getTime()).toEqual(1e3)}),it("should have param indicating that time change is because of auto update",function(){spyOn(e,"publishTimeSelectionChanged"),e.moveToNow(100101,!0),expect(e.publishTimeSelectionChanged).wasCalledWith(!0)}),it("should cache time selection changed params outside of event",function(){var t=n.getTimeSelectionValues();expect(t.isAutoUpdate).toBeFalsy(),e.moveToNow(400404,!0);var r=n.getTimeSelectionValues();expect(r.isAutoUpdate).toBeTruthy(),expect(t.timeRange.startDate).not.toEqual(r.timeRange.startDate)})}),describe("TimeBrowserState Tests with options2",function(){var e,t={firstDate:new Date(810),lastDate:new Date(900),firstVisibleDate:new Date(850),lastVisibleDate:new Date(900),markerDate:new Date(900),isCurrentMode:!1};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(i,"getServerNow").andReturn(new Date(1e3)),e=new n(t),e.getContainerWidth=function(){return o}}),afterEach(function(){}),it("should zoomOut while in the past.",function(){e.zoomOut(),expect(e.firstDate.getTime()).toEqual(765),expect(e.lastDate.getTime()).toEqual(945),expect(e.firstVisibleDate.getTime()).toEqual(850),expect(e.lastVisibleDate.getTime()).toEqual(900)}),it("should zoomOut with a past end point, but in current mode.",function(){e.setCurrentMode(!0),e.zoomOut(),expect(e.firstDate.getTime()).toEqual(765),expect(e.lastDate.getTime()).toEqual(945),expect(e.firstVisibleDate.getTime()).toEqual(850),expect(e.lastVisibleDate.getTime()).toEqual(900)})}),describe("TimeBrowserState with options3",function(){var e="tc_timeControl",t,r={firstDate:new Date(900),lastDate:new Date(1e3),firstVisibleDate:new Date(950),lastVisibleDate:new Date(1e3),isCurrentMode:!0,markerDate:new Date(975),markerContainer:"#"+e};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(i,"getServerNow").andReturn(new Date(1e3)),i.setServerTimezoneOffset(0),t=new n(r),t.getContainerWidth=function(){return o}}),afterEach(function(){$(r.markerContainer).remove(),i.setServerTimezoneOffset(s)});var u=function(e,n){expect(t.getOffsetFromDate(new Date(e))).toEqual(n)};it("TimeBrowserState - offset calculation - time too old ",function(){var e=500,t=0;u(e,t)}),it("TimeBrowserState - offset calculation - start time",function(){var e=900,t=0;u(e,t)}),it("TimeBrowserState - offset calculation - end time",function(){var e=1e3,n=t.getMaximumOffset();u(e,n)}),it("TimeBrowserState - offset calculation - future time",function(){var e=2e3,n=t.getMaximumOffset();u(e,n)}),it("TimeBrowserState - offset calculation - quarter position",function(){var e=925,n=t.getMaximumOffset()/4;u(e,n)}),it("TimeBrowserState - offset calculation - half way position",function(){var e=950,n=t.getMaximumOffset()/2;u(e,n)});var a=function(e,n){expect(t.getDateFromOffset(e).getTime()).toEqual(n)};it("TimeBrowserState - date calculation - time too old ",function(){var e=-20,t=900;a(e,t)}),it("TimeBrowserState - date calculation - start time",function(){var e=0,t=900;a(e,t)}),it("TimeBrowserState - date calculation - end time",function(){var e=t.getMaximumOffset(),n=1e3;a(e,n)}),it("TimeBrowserState - date calculation - future time",function(){var e=t.getMaximumOffset(),n=1e3;a(e,n)}),it("TimeBrowserState - date calculation - quarter position",function(){var e=t.getMaximumOffset()/4,n=925;a(e,n)}),it("TimeBrowserState - date calculation - half way position",function(){var e=t.getMaximumOffset()/2,n=950;a(e,n)})}),describe("TimeBrowserState Tests for different zoomIn cases",function(){var e,t,r,s={firstDate:new Date(910),lastDate:new Date(1e3),firstVisibleDate:new Date(910),lastVisibleDate:new Date(920),markerDate:new Date(915),isCurrentMode:!1},u={firstDate:new Date(910),lastDate:new Date(1e3),firstVisibleDate:new Date(960),lastVisibleDate:new Date(980),markerDate:new Date(970),isCurrentMode:!1},a={firstDate:new Date(900),lastDate:new Date(1e3),firstVisibleDate:new Date(940),lastVisibleDate:new Date(960),markerDate:new Date(950),isCurrentMode:!1};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(i,"getServerNow").andReturn(new Date(1e3)),e=new n(s),t=new n(u),r=new n(a),e.getContainerWidth=function(){return o},t.getContainerWidth=function(){return o},r.getContainerWidth=function(){return o}}),afterEach(function(){}),it("should zoom in for state1.",function(){e.zoomIn(),expect(e.firstDate.getTime()).toEqual(910),expect(e.lastDate.getTime()).toEqual(955),expect(e.firstVisibleDate.getTime()).toEqual(910),expect(e.lastVisibleDate.getTime()).toEqual(920)}),it("should zoom in for state2.",function(){t.zoomIn(),expect(t.firstDate.getTime()).toEqual(955),expect(t.lastDate.getTime()).toEqual(1e3),expect(t.firstVisibleDate.getTime()).toEqual(960),expect(t.lastVisibleDate.getTime()).toEqual(980)}),it("should zoom in for state3.",function(){r.zoomIn(),expect(r.firstDate.getTime()).toEqual(925),expect(r.lastDate.getTime()).toEqual(975),expect(r.firstVisibleDate.getTime()).toEqual(940),expect(r.lastVisibleDate.getTime()).toEqual(960)})}),describe("TimeBrowserState Tests for moveSelection ",function(){var e,t={firstDate:new Date(900),lastDate:new Date(1e3),firstVisibleDate:new Date(910),lastVisibleDate:new Date(920),markerDate:new Date(915),isCurrentMode:!1};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(i,"getServerNow").andReturn(new Date(1e3)),e=new n(t),e.getContainerWidth=function(){return o}}),afterEach(function(){}),it("should move selected range forward to include marker",function(){e.setMarkerDate(new Date(930)),e.moveSelectedRangeToIncludeMarker(),expect(e.firstVisibleDate.getTime()).toEqual(925),expect(e.lastVisibleDate.getTime()).toEqual(935)}),it("should move selected range back to include marker",function(){e.setMarkerDate(new Date(909)),e.moveSelectedRangeToIncludeMarker(),expect(e.firstVisibleDate.getTime()).toEqual(904),expect(e.lastVisibleDate.getTime()).toEqual(914)})})})